/*
	*******************************************************
	* "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
	*******************************************************
	*                                                     *
	* Code source correspond aux exemples traits dans l' *
	* ouvrage.                                            *
	*                                                     *
	* Environment : Borland Developer Studio 2006         *
	* Test sur la version Architecte Franaise patch 1   *
	*                                                     *
	* Copyright   : Olivier Dahan                         *
	*                                                     *
	* Aucune copie, distribution, publication sans l'     *
	* accord exprs de l'auteur.                          *
	* Le prsent code source est fourni "tel quel"       *
	* titre d'illustration des propos techniques du livre *
	* Aucune garantie de fonctionnement ou d'adaptation   *
	* n'est fournie, aucune maintenance corrective ou     *
	* volutive ne sera fournie sur le prsent code.      *
	* Vous utilisez ce code sous votre seule responsabi-  *
	* lit et  vos risques et prils. L'auteur ne serait *
	* tre tenu pour responsable d'ventuelles pertes de  *
	* donnes ou de jouissance qui pourraient rsulter de *
	* l'utilisation du prsent code.                      *
	*                                                     *
	* Contact          : BDSLivre@e-naxos.com             *
	* Site de l'auteur : http://www.e-naxos.com           *
	*******************************************************

*/


using System;

namespace OD.DotNet.CS.Methods
{
	class DemoMthodes
	{
	 // dfinition d'une classe imbrique
	 public class Methodes
	 {
	 // mthode de classe ne retournant pas de valeur
	 public static void EcritBonjour()
	 { Console.Write("Bonjour! "); }

	 // mthode de classe faisant un retour charriot
	 public static void CR()
	 { Console.WriteLine(); }

	 // mthode virtuelle crivant le prnom
	 public virtual void EcritNom()
	 { Console.Write("Olivier "); }

	 // mthode virtuelle doublant un entier et retournant un entier
	 public virtual int Calcul(int i)
	 { return i*2; }

	 // mthode virtuelle overloade avec changement de type retourn
	 public virtual double Calcul(double d)
	 { return d / 2 ; }

	 }

	 // dfinition d'une autre classe imbrique hritant de la prcdente
	 public class Methodes2 : Methodes
	 {
	 // surcharge de la mthode hrite
	 public override void EcritNom()
	 {
	   // syntaxe particulire pour appeler la mthode hrite
	   base.EcritNom();
	   // ajout au comportement de base
	   Console.Write("Dahan ");
	 }
	 // override de la mthode hrite
	 public override int Calcul(int i)
	 { return base.Calcul(i)*2; }
	 // override de la mthode overload hrite
	 public virtual double Calcul(double d)
	 { return base.Calcul(d) / 2 ; }

	 }


		static void Main(string[] args)
		{
		 // appel mthode de classe
		 Methodes.EcritBonjour();
		 // cration d'une instance
		 Methodes m = new Methodes();
		 // appel d'une mthode virtuelle
		 m.EcritNom();
		 // une mthode de classe ne peut tre appele que depuis la classe
		 Methodes.CR();

		 // appel mthode de classe de la classe hrite
		 Methodes2.EcritBonjour();
		 // cration d'une instance
		 Methodes2 mm = new Methodes2();
		 // appel  la mthode surcharge
		 mm.EcritNom();

		 for (int i=0;i<2;i++) Methodes.CR(); // saute 2 lignes

		 Console.WriteLine("Le calcul original pour {0} donne {1}",5,m.Calcul(5));
		 Console.WriteLine("Le calcul hrit pour {0} donne {1}",5,mm.Calcul(5));

		 Methodes.CR();
		 Console.WriteLine("Utilisation de la mthode de calcul en overload sur des doubles:");
		 Methodes.CR();

		 Console.WriteLine("Le calcul original pour {0} donne {1}",5.6,m.Calcul(5.6));
		 Console.WriteLine("Le calcul hrit pour {0} donne {1}",5.6,mm.Calcul(5.6));

		 Console.ReadLine(); // pause sur la console
		}
	}
}
