/*
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

*/



// Dmonstration pour le livre Delphi.NET Studio - (c) Olivier Dahan
// Le prsent code dmontre aussi comment baliser le code pour produire
// automatique la documentation XML


using System;

namespace OD.DotNet.CS.Fields
{
///<summary>
///Commentaire globale dcrivant la classe "livre" </summary>
///<remarks>Cet exemple C# traite des champs et proprits.
///La balise remarks permet de saisir un texte complmentaire long
///</remarks>

	class livre
	{
      ///<summary>La classe test contient les dfinitions exemples</summary>
	  class test
	  {
	   // dclaration d'une constante de classe
	   public const int constante = 50;

	   // dfinition d'un champ de classe
	   public static int ChampStatic = 1;
	   ///<summary>Dfinition d'un champ de classe en lecture seule</summary>	
	   public static readonly int ChampRO = 5;

	   // dfinition d'une proprit de classe
	   private static int x; // le champ priv
	   public static int X // la proprit publique
	   {
		get { return x; } // retourne x
		set { x = (value<10) ? value:-1; } // si >=10 stocke -1 sinon la valeur
	   }

	   // dfinition d'un champ priv
	   private string chaine;
	   // dfinition d'une proprit publique sur le champ priv
	   public string Chaine
		{
		 get { return chaine; } // getter
		 set { chaine = value+" !"; } // setter
		}

	   // dclaration d'un tableau de chaine priv
	   private string[] liste;
	   // dfinition d'un Indexer
	   public string this[int i]
	   {
		get { return (i>=0 && i<6) ? this.liste[i] : "erreur";}
		set { if (i>=0 && i<6) this.liste[i]=value; }
	   }

	   // constructeur static
	   static test()
	   {
		ChampRO = 12; // la valeur 5 stocke plus haut ne sera vue...
	   }

	   // constructeur dynamique
	   public test()
	   {
		chaine = "chaine initialise";
        liste = new string[5];
	   }


	  }

		///<summary>Point d'entre du programme console de test</summary>
		///<param name='args'>Liste des arguments en ligne de commande</param>
		static void Main(string[] args)
		{
		 // accs au champ de classe
		 Console.WriteLine("Le champ static vaut {0}",test.ChampStatic);
		 // modification du champ de classe
		 test.ChampStatic = 12;
		 Console.WriteLine("Le champ static vaut {0}",test.ChampStatic);
		 // accs au champ readonly avant la construction d'une instance
		 Console.WriteLine("Le champ static readonly ChampRO vaut {0}",test.ChampRO);
		 // cration d'une instance
		 test t = new test();
		 // lecture de la chaine initialise dans le constructeur
		 Console.WriteLine("La proprit chane vaut {0}",t.Chaine);
		 // criture de la proprit chane
		 t.Chaine = "bonjour";
		 // lecture de la proprit chane
		 Console.WriteLine("La proprit chane vaut {0}",t.Chaine);
		 Console.WriteLine("La proprit de classe X vaut {0}",test.X);
		 test.X = 6;
		 Console.WriteLine("La proprit de classe X vaut {0}",test.X);
		 test.X = 12;
		 Console.WriteLine("La proprit de classe X vaut {0}",test.X);

		 // test.ChampRO = 12; refus  la compilation, readonly

		 // accs  la constante de classe
		 Console.WriteLine("La constante de classe 'constante' vaut {0}",test.constante);

		 // indexation directe de l'instance comme si c'tait un tableau
		 t[2]="Olivier"; // init de la cellule 2
		 // accs  diffrentes cellules
		 Console.WriteLine("La cellule 0 du tableau vaut {0}",t[0]); // non init donc vide
		 Console.WriteLine("La cellule 2 du tableau vaut {0}",t[2]); // "Olivier"
		 Console.WriteLine("La cellule 8 du tableau vaut {0}",t[8]); // "erreur" car > 5



		 Console.ReadLine();
		}
	}
}
