{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}


program OD.DotNet.Delphi.Delegates.Multicast;

{$APPTYPE CONSOLE}


type
 // le type du dlgu, type procdural delphi
 MonTypeDeDlgation = procedure (const i:integer) of object;

 // la classe publiant l'vnement multi diffusion
 MaClasse = Class
  private
  // dclaration traditionnelle de la variable du gestionnaire dlgu
  fDlgu : MonTypeDeDlgation;
  public
  // l'opration qui dclenche la dlgation
  procedure FaitUneOpration;
  // l'vnement multi diffusion add et remove remplacent read / write
  property OnDelegation : MonTypeDeDlgation add fDlgu remove fDlgu;
  end;

{ MaClasse }

procedure MaClasse.FaitUneOpration;
begin
 // si la variable du dlgu est assigne, appel avec un paramtre
 if assigned(fDlgu) then fDlgu(86);
end;

// la classe qui contiendra les mthodes appeles
type
 MaClasseOutil = class
 public
  // deux mthodes tout  fait "normales" respectant le
  // prototypage du dlgu
  procedure DivisePar2(const i:integer);
  procedure MultipliePar3(const i:integer);
 end;

{ MaClasseUtilisatrice }

procedure MaClasseOutil.DivisePar2(const i: integer);
begin
 Console.WriteLine('La valeur {0} divise par 2 = {1}',[i,i div 2]);
end;

procedure MaClasseOutil.MultipliePar3(const i: integer);
begin
 Console.WriteLine('La valeur {0} multiplie par 3 = {1}',[i,i * 3]);
end;

// instances des deux classes
var monObject : MaClasse;
    monObjetOutil : MaClasseOutil;

begin
  // cration des instances
  monObject := MaClasse.Create;
  monObjetOutil := MaClasseOutil.Create;

  // ajout des deux mthodes  l'vnement OnDlgation
  include(monObject.OnDelegation,monObjetOutil.Divisepar2);
  include(monObject.OnDelegation,monObjetOutil.Multipliepar3);

  // appel de la mthode qui gnre l'appel aux
  // gestionnaires de l'vnement OnDlgation
  monObject.FaitUneOpration;

  // ici la console affiche les deux lignes,
  // la division par 2 et la multiplication par 3

  Console.ReadLine; // une pause.. tapez return...
end.


